package org.tip.puck.sequences;

import org.apache.commons.lang3.StringUtils;
import org.tip.puck.net.relations.Relation;
import org.tip.puck.net.relations.Relations;
import org.tip.puck.segmentation.Segmentation;
import org.tip.puck.util.NumberablesHashMap;

public class Sequences extends NumberablesHashMap<Sequence> {
	
	String label;
	
	public Sequences (Segmentation segmentation, String label, String modelLabel, String orderLabel){
		
		this.label = label;
		
		Relations relations = segmentation.getCurrentRelations().getByModelName(modelLabel);
		
		for (Relation relation : relations){
			
			Sequence sequence = null;
			
			String sequenceId = relation.getAttributeValue(label);
			
			if (StringUtils.isNumeric(sequenceId)){
				sequence = getById(Integer.parseInt(sequenceId));
				if (sequence == null){
					sequence = new Sequence(Integer.parseInt(sequenceId));
					put(sequence);
				}
			}
			
			sequence.put(relation.getAttributeValue(orderLabel),relation);
		}
		
	}
	

}
